diff -ru extract/pidgin-2.10.9/libpurple/log.h libpurple/log.h
--- extract/pidgin-2.10.9/libpurple/log.h	2014-02-02 22:29:17.000000000 +0100
+++ libpurple/log.h	2015-05-04 13:42:04.492970478 +0200
@@ -1,583 +1,8 @@
-/**
- * @file log.h Logging API
- * @ingroup core
- * @see @ref log-signals
- */
-
-/* purple
- *
- * Purple is the legal property of its developers, whose names are too numerous
- * to list here.  Please refer to the COPYRIGHT file distributed with this
- * source distribution.
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02111-1301  USA
- */
 #ifndef _PURPLE_LOG_H_
 #define _PURPLE_LOG_H_
 
-#include <stdio.h>
-
-
-/********************************************************
- * DATA STRUCTURES **************************************
- ********************************************************/
-
-typedef struct _PurpleLog PurpleLog;
-typedef struct _PurpleLogLogger PurpleLogLogger;
-typedef struct _PurpleLogCommonLoggerData PurpleLogCommonLoggerData;
-typedef struct _PurpleLogSet PurpleLogSet;
-
-typedef enum {
-	PURPLE_LOG_IM,
-	PURPLE_LOG_CHAT,
-	PURPLE_LOG_SYSTEM
-} PurpleLogType;
-
-typedef enum {
-	PURPLE_LOG_READ_NO_NEWLINE = 1
-} PurpleLogReadFlags;
-
-#include "account.h"
-#include "conversation.h"
-
-typedef void (*PurpleLogSetCallback) (GHashTable *sets, PurpleLogSet *set);
-
-/**
- * A log logger.
- *
- * This struct gets filled out and is included in the PurpleLog.  It contains everything
- * needed to write and read from logs.
- */
-struct _PurpleLogLogger {
-	char *name;               /**< The logger's name */
-	char *id;                 /**< an identifier to refer to this logger */
-
-	/** This gets called when the log is first created.
-	    I don't think this is actually needed. */
-	void (*create)(PurpleLog *log);
-
-	/** This is used to write to the log file */
-	gsize (*write)(PurpleLog *log,
-		     PurpleMessageFlags type,
-		     const char *from,
-		     time_t time,
-		     const char *message);
-
-	/** Called when the log is destroyed */
-	void (*finalize)(PurpleLog *log);
-
-	/** This function returns a sorted GList of available PurpleLogs */
-	GList *(*list)(PurpleLogType type, const char *name, PurpleAccount *account);
-
-	/** Given one of the logs returned by the logger's list function,
-	 *  this returns the contents of the log in GtkIMHtml markup */
-	char *(*read)(PurpleLog *log, PurpleLogReadFlags *flags);
-
-	/** Given one of the logs returned by the logger's list function,
-	 *  this returns the size of the log in bytes */
-	int (*size)(PurpleLog *log);
-
-	/** Returns the total size of all the logs. If this is undefined a default
-	 *  implementation is used */
-	int (*total_size)(PurpleLogType type, const char *name, PurpleAccount *account);
-
-	/** This function returns a sorted GList of available system PurpleLogs */
-	GList *(*list_syslog)(PurpleAccount *account);
-
-	/** Adds PurpleLogSets to a GHashTable. By passing the data in the PurpleLogSets
-	 *  to list, the caller can get every available PurpleLog from the logger.
-	 *  Loggers using purple_log_common_writer() (or otherwise storing their
-	 *  logs in the same directory structure as the stock loggers) do not
-	 *  need to implement this function.
-	 *
-	 *  Loggers which implement this function must create a PurpleLogSet,
-	 *  then call @a cb with @a sets and the newly created PurpleLogSet. */
-	void (*get_log_sets)(PurpleLogSetCallback cb, GHashTable *sets);
-
-	/* Attempts to delete the specified log, indicating success or failure */
-	gboolean (*remove)(PurpleLog *log);
-
-	/* Tests whether a log is deletable */
-	gboolean (*is_deletable)(PurpleLog *log);
-
-	void (*_purple_reserved1)(void);
-	void (*_purple_reserved2)(void);
-	void (*_purple_reserved3)(void);
-	void (*_purple_reserved4)(void);
-};
-
-/**
- * A log.  Not the wooden type.
- */
-struct _PurpleLog {
-	PurpleLogType type;                     /**< The type of log this is */
-	char *name;                           /**< The name of this log */
-	PurpleAccount *account;                 /**< The account this log is taking
-	                                           place on */
-	PurpleConversation *conv;               /**< The conversation being logged */
-	time_t time;                          /**< The time this conversation
-	                                           started, converted to the local timezone */
-
-	PurpleLogLogger *logger;                /**< The logging mechanism this log
-	                                           is to use */
-	void *logger_data;                    /**< Data used by the log logger */
-	struct tm *tm;                        /**< The time this conversation
-	                                           started, saved with original
-	                                           timezone data, if available and
-	                                           if struct tm has the BSD
-	                                           timezone fields, else @c NULL.
-	                                           Do NOT modify anything in this struct.*/
-
-	/* IMPORTANT: Some code in log.c allocates these without zeroing them.
-	 * IMPORTANT: Update that code if you add members here. */
-};
-
-/**
- * A common logger_data struct containing a file handle and path, as well
- * as a pointer to something else for additional data.
- */
-struct _PurpleLogCommonLoggerData {
-	char *path;
-	FILE *file;
-	void *extra_data;
-};
-
-/**
- * Describes available logs.
- *
- * By passing the elements of this struct to purple_log_get_logs(), the caller
- * can get all available PurpleLogs.
- */
-struct _PurpleLogSet {
-	PurpleLogType type;                     /**< The type of logs available */
-	char *name;                           /**< The name of the logs available */
-	PurpleAccount *account;                 /**< The account the available logs
-	                                           took place on. This will be
-	                                           @c NULL if the account no longer
-	                                           exists. (Depending on a
-	                                           logger's implementation of
-	                                           list, it may not be possible
-	                                           to load such logs.) */
-	gboolean buddy;                       /**< Is this (account, name) a buddy
-	                                           on the buddy list? */
-	char *normalized_name;                /**< The normalized version of
-	                                           @a name. It must be set, and
-	                                           may be set to the same pointer
-	                                           value as @a name. */
-
-	/* IMPORTANT: Some code in log.c allocates these without zeroing them.
-	 * IMPORTANT: Update that code if you add members here. */
-};
-
-#ifdef __cplusplus
-extern "C" {
-#endif
-
-/***************************************/
-/** @name Log Functions                */
-/***************************************/
-/*@{*/
-
-/**
- * Creates a new log
- *
- * @param type        The type of log this is.
- * @param name        The name of this conversation (buddy name, chat name,
- *                    etc.)
- * @param account     The account the conversation is occurring on
- * @param conv        The conversation being logged
- * @param time        The time this conversation started
- * @param tm          The time this conversation started, with timezone data,
- *                    if available and if struct tm has the BSD timezone fields.
- * @return            The new log
- */
-PurpleLog *purple_log_new(PurpleLogType type, const char *name, PurpleAccount *account,
-                      PurpleConversation *conv, time_t time, const struct tm *tm);
-
-/**
- * Frees a log
- *
- * @param log         The log to destroy
- */
-void purple_log_free(PurpleLog *log);
-
-/**
- * Writes to a log file. Assumes you have checked preferences already.
- *
- * @param log          The log to write to
- * @param type         The type of message being logged
- * @param from         Whom this message is coming from, or @c NULL for
- *                     system messages
- * @param time         A timestamp in UNIX time
- * @param message      The message to log
- */
-void purple_log_write(PurpleLog *log,
-		    PurpleMessageFlags type,
-		    const char *from,
-		    time_t time,
-		    const char *message);
-
-/**
- * Reads from a log
- *
- * @param log   The log to read from
- * @param flags The returned logging flags.
- *
- * @return The contents of this log in Purple Markup.
- */
-char *purple_log_read(PurpleLog *log, PurpleLogReadFlags *flags);
-
-/**
- * Returns a list of all available logs
- *
- * @param type                The type of the log
- * @param name                The name of the log
- * @param account             The account
- * @return                    A sorted list of PurpleLogs
- */
-GList *purple_log_get_logs(PurpleLogType type, const char *name, PurpleAccount *account);
-
-/**
- * Returns a GHashTable of PurpleLogSets.
- *
- * A "log set" here means the information necessary to gather the
- * PurpleLogs for a given buddy/chat. This information would be passed
- * to purple_log_list to get a list of PurpleLogs.
- *
- * The primary use of this function is to get a list of everyone the
- * user has ever talked to (assuming he or she uses logging).
- *
- * The GHashTable that's returned will free all log sets in it when
- * destroyed. If a PurpleLogSet is removed from the GHashTable, it
- * must be freed with purple_log_set_free().
- *
- * @return A GHashTable of all available unique PurpleLogSets
- */
-GHashTable *purple_log_get_log_sets(void);
-
-/**
- * Returns a list of all available system logs
- *
- * @param account The account
- * @return        A sorted list of PurpleLogs
- */
-GList *purple_log_get_system_logs(PurpleAccount *account);
-
-/**
- * Returns the size of a log
- *
- * @param log                 The log
- * @return                    The size of the log, in bytes
- */
-int purple_log_get_size(PurpleLog *log);
-
-/**
- * Returns the size, in bytes, of all available logs in this conversation
- *
- * @param type                The type of the log
- * @param name                The name of the log
- * @param account             The account
- * @return                    The size in bytes
- */
-int purple_log_get_total_size(PurpleLogType type, const char *name, PurpleAccount *account);
-
-/**
- * Returns the activity score of a log, based on total size in bytes,
- * which is then decayed based on age
- *
- * @param type                The type of the log
- * @param name                The name of the log
- * @param account             The account
- * @return                    The activity score
- *
- * @since 2.6.0
- */
-int purple_log_get_activity_score(PurpleLogType type, const char *name, PurpleAccount *account);
-
-/**
- * Tests whether a log is deletable
- *
- * A return value of @c FALSE indicates that purple_log_delete() will fail on this
- * log, unless something changes between the two calls.  A return value of @c TRUE,
- * however, does not guarantee the log can be deleted.
- *
- * @param log                 The log
- * @return                    A boolean indicating if the log is deletable
- */
-gboolean purple_log_is_deletable(PurpleLog *log);
-
-/**
- * Deletes a log
- *
- * @param log                 The log
- * @return                    A boolean indicating success or failure
- */
-gboolean purple_log_delete(PurpleLog *log);
-
-/**
- * Returns the default logger directory Purple uses for a given account
- * and username.  This would be where Purple stores logs created by
- * the built-in text or HTML loggers.
- *
- * @param type                The type of the log.
- * @param name                The name of the log.
- * @param account             The account.
- * @return                    The default logger directory for Purple.
- */
-char *purple_log_get_log_dir(PurpleLogType type, const char *name, PurpleAccount *account);
-
-/**
- * Implements GCompareFunc for PurpleLogs
- *
- * @param y                   A PurpleLog
- * @param z                   Another PurpleLog
- * @return                    A value as specified by GCompareFunc
- */
-gint purple_log_compare(gconstpointer y, gconstpointer z);
-
-/**
- * Implements GCompareFunc for PurpleLogSets
- *
- * @param y                   A PurpleLogSet
- * @param z                   Another PurpleLogSet
- * @return                    A value as specified by GCompareFunc
- */
-gint purple_log_set_compare(gconstpointer y, gconstpointer z);
-
-/**
- * Frees a log set
- *
- * @param set         The log set to destroy
- */
-void purple_log_set_free(PurpleLogSet *set);
-
-/*@}*/
-
-/******************************************/
-/** @name Common Logger Functions         */
-/******************************************/
-/*@{*/
-
-/**
- * Opens a new log file in the standard Purple log location
- * with the given file extension, named for the current time,
- * for writing.  If a log file is already open, the existing
- * file handle is retained.  The log's logger_data value is
- * set to a PurpleLogCommonLoggerData struct containing the log
- * file handle and log path.
- *
- * This function is intended to be used as a "common"
- * implementation of a logger's @c write function.
- * It should only be passed to purple_log_logger_new() and never
- * called directly.
- *
- * @param log   The log to write to.
- * @param ext   The file extension to give to this log file.
- */
-void purple_log_common_writer(PurpleLog *log, const char *ext);
-
-/**
- * Returns a sorted GList of PurpleLogs of the requested type.
- *
- * This function should only be used with logs that are written
- * with purple_log_common_writer().  It's intended to be used as
- * a "common" implementation of a logger's @c list function.
- * It should only be passed to purple_log_logger_new() and never
- * called directly.
- *
- * @param type     The type of the logs being listed.
- * @param name     The name of the log.
- * @param account  The account of the log.
- * @param ext      The file extension this log format uses.
- * @param logger   A reference to the logger struct for this log.
- *
- * @return A sorted GList of PurpleLogs matching the parameters.
- */
-GList *purple_log_common_lister(PurpleLogType type, const char *name,
-							  PurpleAccount *account, const char *ext,
-							  PurpleLogLogger *logger);
-
-/**
- * Returns the total size of all the logs for a given user, with
- * a given extension.
- *
- * This function should only be used with logs that are written
- * with purple_log_common_writer().  It's intended to be used as
- * a "common" implementation of a logger's @c total_size function.
- * It should only be passed to purple_log_logger_new() and never
- * called directly.
- *
- * @param type     The type of the logs being sized.
- * @param name     The name of the logs to size
- *                 (e.g. the username or chat name).
- * @param account  The account of the log.
- * @param ext      The file extension this log format uses.
- *
- * @return The size of all the logs with the specified extension
- *         for the specified user.
- */
-int purple_log_common_total_sizer(PurpleLogType type, const char *name,
-								PurpleAccount *account, const char *ext);
-
-/**
- * Returns the size of a given PurpleLog.
- *
- * This function should only be used with logs that are written
- * with purple_log_common_writer().  It's intended to be used as
- * a "common" implementation of a logger's @c size function.
- * It should only be passed to purple_log_logger_new() and never
- * called directly.
- *
- * @param log      The PurpleLog to size.
- *
- * @return An integer indicating the size of the log in bytes.
- */
-int purple_log_common_sizer(PurpleLog *log);
-
-/**
- * Deletes a log
- *
- * This function should only be used with logs that are written
- * with purple_log_common_writer().  It's intended to be used as
- * a "common" implementation of a logger's @c delete function.
- * It should only be passed to purple_log_logger_new() and never
- * called directly.
- *
- * @param log      The PurpleLog to delete.
- *
- * @return A boolean indicating success or failure.
- */
-gboolean purple_log_common_deleter(PurpleLog *log);
-
-/**
- * Checks to see if a log is deletable
- *
- * This function should only be used with logs that are written
- * with purple_log_common_writer().  It's intended to be used as
- * a "common" implementation of a logger's @c is_deletable function.
- * It should only be passed to purple_log_logger_new() and never
- * called directly.
- *
- * @param log      The PurpleLog to check.
- *
- * @return A boolean indicating if the log is deletable.
- */
-gboolean purple_log_common_is_deletable(PurpleLog *log);
-
-/*@}*/
-
-/******************************************/
-/** @name Logger Functions                */
-/******************************************/
-/*@{*/
-
-/**
- * Creates a new logger
- *
- * @param id           The logger's id.
- * @param name         The logger's name.
- * @param functions    The number of functions being passed. The following
- *                     functions are currently available (in order): @c create,
- *                     @c write, @c finalize, @c list, @c read, @c size,
- *                     @c total_size, @c list_syslog, @c get_log_sets,
- *                     @c remove, @c is_deletable.
- *                     For details on these functions, see PurpleLogLogger.
- *                     Functions may not be skipped. For example, passing
- *                     @c create and @c write is acceptable (for a total of
- *                     two functions). Passing @c create and @c finalize,
- *                     however, is not. To accomplish that, the caller must
- *                     pass @c create, @c NULL (a placeholder for @c write),
- *                     and @c finalize (for a total of 3 functions).
- *
- * @return The new logger
- */
-PurpleLogLogger *purple_log_logger_new(const char *id, const char *name, int functions, ...);
-
-/**
- * Frees a logger
- *
- * @param logger       The logger to free
- */
-void purple_log_logger_free(PurpleLogLogger *logger);
-
-/**
- * Adds a new logger
- *
- * @param logger       The new logger to add
- */
-void purple_log_logger_add (PurpleLogLogger *logger);
-
-/**
- *
- * Removes a logger
- *
- * @param logger       The logger to remove
- */
-void purple_log_logger_remove (PurpleLogLogger *logger);
-
-/**
- *
- * Sets the current logger
- *
- * @param logger       The logger to set
- */
-void purple_log_logger_set (PurpleLogLogger *logger);
-
-/**
- *
- * Returns the current logger
- *
- * @return logger      The current logger
- */
-PurpleLogLogger *purple_log_logger_get (void);
-
-/**
- * Returns a GList containing the IDs and names of the registered
- * loggers.
- *
- * @return The list of IDs and names.
- */
-GList *purple_log_logger_get_options(void);
-
-/**************************************************************************/
-/** @name Log Subsystem                                                   */
-/**************************************************************************/
-/*@{*/
-
-/**
- * Initializes the log subsystem.
- */
-void purple_log_init(void);
-
-/**
- * Returns the log subsystem handle.
- *
- * @return The log subsystem handle.
- */
-void *purple_log_get_handle(void);
-
-/**
- * Uninitializes the log subsystem.
- */
-void purple_log_uninit(void);
-
-/*@}*/
-
-
-#ifdef __cplusplus
-}
-#endif
+#define purple_log_init()
+#define purple_log_uninit()
+#define PurpleLog void
 
 #endif /* _PURPLE_LOG_H_ */
Only in libpurple: Makefile.in
Only in extract/pidgin-2.10.9/libpurple: marshallers.c
Only in extract/pidgin-2.10.9/libpurple: marshallers.h
Only in extract/pidgin-2.10.9/libpurple: marshallers.list
Only in extract/pidgin-2.10.9/libpurple: media
Only in extract/pidgin-2.10.9/libpurple: media.c
Only in extract/pidgin-2.10.9/libpurple: media-gst.h
Only in extract/pidgin-2.10.9/libpurple: media.h
Only in extract/pidgin-2.10.9/libpurple: mediamanager.c
Only in extract/pidgin-2.10.9/libpurple: mediamanager.h
Only in libpurple: moz.build
diff -ru extract/pidgin-2.10.9/libpurple/network.c libpurple/network.c
--- extract/pidgin-2.10.9/libpurple/network.c	2014-02-02 22:29:17.000000000 +0100
+++ libpurple/network.c	2015-05-04 13:42:04.496970477 +0200
@@ -24,6 +24,12 @@
  * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02111-1301  USA
  */
 
+#ifdef _WIN32
+#undef _WIN32_WINNT
+#define _WIN32_WINNT 0x0501
+#define INCL_WINSOCK_API_TYPEDEFS 1
+#endif
+
 #include "internal.h"
 
 #ifndef _WIN32
@@ -35,7 +41,7 @@
 #ifdef HAVE_GETIFADDRS
 #include <ifaddrs.h>
 #endif
-#else
+#elif 0
 #include <nspapi.h>
 #endif
 
@@ -81,17 +87,16 @@
 static NMState nm_state = NM_STATE_UNKNOWN;
 static gboolean have_nm_state = FALSE;
 
-#elif defined _WIN32
+#elif 0
 static int current_network_count;
 
 /* Mutex for the other global vars */
 static GStaticMutex mutex = G_STATIC_MUTEX_INIT;
 static gboolean network_initialized = FALSE;
 static HANDLE network_change_handle = NULL;
-static int (WSAAPI *MyWSANSPIoctl) (
-		HANDLE hLookup, DWORD dwControlCode, LPVOID lpvInBuffer,
-		DWORD cbInBuffer, LPVOID lpvOutBuffer, DWORD cbOutBuffer,
-		LPDWORD lpcbBytesReturned, LPWSACOMPLETION lpCompletion) = NULL;
+static LPFN_WSANSPIOCTL MyWSANSPIoctl = NULL;
+#else
+static network_available_callback available_callback = NULL;
 #endif
 
 struct _PurpleNetworkListenData {
@@ -611,7 +616,7 @@
 	return ntohs(addr.sin_port);
 }
 
-#ifdef _WIN32
+#if 0
 #ifndef NS_NLA
 #define NS_NLA 15
 #endif
@@ -850,9 +855,12 @@
 
 	return FALSE;
 
-#elif defined _WIN32
+#elif 0
 	return (current_network_count > 0 || force_online);
 #else
+	if (available_callback)
+		return (available_callback());
+
 	return TRUE;
 #endif
 }
@@ -1140,7 +1148,7 @@
 #ifdef HAVE_NETWORKMANAGER
 	GError *error = NULL;
 #endif
-#ifdef _WIN32
+#if 0
 	GError *err = NULL;
 	gint cnt = wpurple_get_connected_network_count();
 
@@ -1161,7 +1169,6 @@
 	purple_prefs_add_string("/purple/network/stun_server", "");
 	purple_prefs_add_string("/purple/network/turn_server", "");
 	purple_prefs_add_int   ("/purple/network/turn_port", 3478);
-	purple_prefs_add_int	 ("/purple/network/turn_port_tcp", 3478);
 	purple_prefs_add_string("/purple/network/turn_username", "");
 	purple_prefs_add_string("/purple/network/turn_password", "");
 	purple_prefs_add_bool  ("/purple/network/auto_ip", TRUE);
@@ -1236,7 +1243,7 @@
 		dbus_g_connection_unref(nm_conn);
 #endif
 
-#ifdef _WIN32
+#if 0
 	g_static_mutex_lock(&mutex);
 	network_initialized = FALSE;
 	if (network_change_handle != NULL) {
@@ -1269,3 +1276,15 @@
 	/* TODO: clean up remaining port mappings, note calling
 	 purple_upnp_remove_port_mapping from here doesn't quite work... */
 }
+
+void
+purple_network_configuration_changed(void)
+{
+	purple_signal_emit(purple_network_get_handle(), "network-configuration-changed", NULL);
+}
+
+void
+purple_network_set_available_callback(network_available_callback cb)
+{
+	available_callback = cb;
+}
diff -ru extract/pidgin-2.10.9/libpurple/network.h libpurple/network.h
--- extract/pidgin-2.10.9/libpurple/network.h	2014-02-02 22:29:17.000000000 +0100
+++ libpurple/network.h	2015-05-04 13:42:04.496970477 +0200
@@ -350,6 +350,24 @@
  */
 void purple_network_uninit(void);
 
+/**
+ * Emits the network-configuration-changed signal
+ */
+void
+purple_network_configuration_changed(void);
+
+/**
+ * Function pointer to a function indicating if network is available
+ */
+typedef gboolean (*network_available_callback)(void);
+
+/**
+ * Sets the callback function to be used to query the UI about the
+ * availability of the network.
+ */
+void
+purple_network_set_available_callback(network_available_callback cb);
+
 /*@}*/
 
 #ifdef __cplusplus
diff -ru extract/pidgin-2.10.9/libpurple/notify.c libpurple/notify.c
--- extract/pidgin-2.10.9/libpurple/notify.c	2014-02-02 22:29:17.000000000 +0100
+++ libpurple/notify.c	2015-05-04 13:42:04.496970477 +0200
@@ -28,6 +28,7 @@
 #include "internal.h"
 #include "dbus-maybe.h"
 #include "notify.h"
+#include "debug.h"
 
 static PurpleNotifyUiOps *notify_ui_ops = NULL;
 static GList *handles = NULL;
@@ -85,6 +86,18 @@
 		}
 
 	}
+	else {
+		int level;
+		if (type == PURPLE_NOTIFY_MSG_ERROR)
+			level = PURPLE_DEBUG_ERROR;
+		else if (type == PURPLE_NOTIFY_MSG_WARNING)
+			level = PURPLE_DEBUG_WARNING;
+		else
+			level = PURPLE_DEBUG_INFO;
+		purple_debug(level, "notify", "Notification: %s (%s)",
+			     title ? title : "(null)",
+			     primary ? primary : "(null)");
+	}
 
 	if (cb != NULL)
 		cb(user_data);
diff -ru extract/pidgin-2.10.9/libpurple/plugin.c libpurple/plugin.c
--- extract/pidgin-2.10.9/libpurple/plugin.c	2014-02-02 22:29:17.000000000 +0100
+++ libpurple/plugin.c	2015-05-04 13:42:04.500970477 +0200
@@ -33,7 +33,6 @@
 #include "request.h"
 #include "signals.h"
 #include "util.h"
-#include "valgrind.h"
 #include "version.h"
 
 typedef struct
@@ -73,6 +72,8 @@
 
 #ifdef PURPLE_PLUGINS
 
+#define RUNNING_ON_VALGRIND 0
+
 static gboolean
 has_file_extension(const char *filename, const char *ext)
 {
@@ -283,8 +284,9 @@
 				purple_debug_error("plugins", "%s is not loadable: %s\n",
 						 plugin->path, plugin->error);
 			}
+#if 0
 			plugin->handle = g_module_open(filename, G_MODULE_BIND_LAZY | G_MODULE_BIND_LOCAL);
-
+#endif
 			if (plugin->handle == NULL)
 			{
 #ifdef _WIN32
@@ -788,9 +790,9 @@
 void
 purple_plugin_destroy(PurplePlugin *plugin)
 {
-#ifdef PURPLE_PLUGINS
 	g_return_if_fail(plugin != NULL);
 
+#ifdef PURPLE_PLUGINS
 	if (purple_plugin_is_loaded(plugin))
 		purple_plugin_unload(plugin);
 
@@ -886,6 +888,17 @@
 				loader_info->destroy(plugin);
 		}
 	}
+#else
+	if (plugin->info != NULL) {
+		if (PURPLE_IS_PROTOCOL_PLUGIN(plugin))
+			protocol_plugins = g_list_remove(protocol_plugins, plugin);
+
+		if (plugin->info->unload)
+			plugin->info->unload(plugin);
+	}
+
+	plugins = g_list_remove(plugins, plugin);
+#endif /* !PURPLE_PLUGINS */
 
 	g_free(plugin->path);
 	g_free(plugin->error);
@@ -893,7 +906,6 @@
 	PURPLE_DBUS_UNREGISTER_POINTER(plugin);
 
 	g_free(plugin);
-#endif /* !PURPLE_PLUGINS */
 }
 
 gboolean
@@ -1179,7 +1191,9 @@
 purple_plugins_init(void) {
 	void *handle = purple_plugins_get_handle();
 
+#ifdef LIBDIR
 	purple_plugins_add_search_path(LIBDIR);
+#endif
 
 	purple_signal_register(handle, "plugin-load",
 						 purple_marshal_VOID__POINTER,
@@ -1256,14 +1270,11 @@
 void
 purple_plugins_destroy_all(void)
 {
-#ifdef PURPLE_PLUGINS
-
 	while (plugins != NULL)
 		purple_plugin_destroy(plugins->data);
-
-#endif /* PURPLE_PLUGINS */
 }
 
+#if 0
 void
 purple_plugins_save_loaded(const char *key)
 {
@@ -1345,6 +1356,7 @@
 	g_list_free(files);
 #endif /* PURPLE_PLUGINS */
 }
+#endif
 
 
 void
diff -ru extract/pidgin-2.10.9/libpurple/plugin.h libpurple/plugin.h
--- extract/pidgin-2.10.9/libpurple/plugin.h	2014-02-02 22:29:17.000000000 +0100
+++ libpurple/plugin.h	2015-05-04 13:42:04.500970477 +0200
@@ -30,7 +30,9 @@
 #define _PURPLE_PLUGIN_H_
 
 #include <glib.h>
-#include <gmodule.h>
+#ifdef PURPLE_PLUGINS
+# include <gmodule.h>
+#endif
 #include "signals.h"
 #include "value.h"
 
@@ -217,6 +219,7 @@
 /**
  * Handles the initialization of modules.
  */
+#if 0
 #if !defined(PURPLE_PLUGINS) || defined(PURPLE_STATIC_PRPL)
 # define _FUNC_NAME(x) purple_init_##x##_plugin
 # define PURPLE_INIT_PLUGIN(pluginname, initfunc, plugininfo) \
@@ -237,7 +240,21 @@
 		return purple_plugin_register(plugin); \
 	}
 #endif
+#endif
 
+#ifdef PURPLE_STATIC_PRPL
+# define _FUNC_NAME(x) purple_init_##x##_plugin
+#else
+# define _FUNC_NAME(x) purple_plugin_register_self
+#endif
+
+#define PURPLE_INIT_PLUGIN(pluginname, initfunc, plugininfo) \
+	gboolean _FUNC_NAME(pluginname)(void) { \
+		PurplePlugin *plugin = purple_plugin_new(TRUE, NULL); \
+		plugin->info = &(plugininfo); \
+		initfunc((plugin)); \
+		return purple_plugin_register(plugin); \
+	}
 
 #ifdef __cplusplus
 extern "C" {
@@ -536,21 +553,6 @@
 void purple_plugins_destroy_all(void);
 
 /**
- * Saves the list of loaded plugins to the specified preference key
- *
- * @param key The preference key to save the list of plugins to.
- */
-void purple_plugins_save_loaded(const char *key);
-
-/**
- * Attempts to load all the plugins in the specified preference key
- * that were loaded when purple last quit.
- *
- * @param key The preference key containing the list of plugins.
- */
-void purple_plugins_load_saved(const char *key);
-
-/**
  * Probes for plugins in the registered module paths.
  *
  * @param ext The extension type to probe for, or @c NULL for all.
Only in extract/pidgin-2.10.9/libpurple: plugins
Only in extract/pidgin-2.10.9/libpurple: pounce.c
Only in extract/pidgin-2.10.9/libpurple: pounce.h
